/* DYN */
signal on error name fineko
signal on failure name fineko
signal on halt name fineko

parse value init() with rcy
if rcy \= 0 then signal fineko

parse upper arg filein dinamica

if (filein == "") | (dinamica == "") then do
  say "DYN:"
  say "Espande/comprime la gamma dinamica di un file WAV stereo"
  say ""
  say "Uso:"
  say "      DYN nome_file dinamica"
  say ""
  say "Parametri:"
  say "      nome_file    il nome di un file WAV (con estenzione)"
  say "      dinamica     (<1=compressione, >1=espansione)"
  return 1
  end



call SysCls
fc=44100
filetmp="tmp.wav"
t=time(R)

c = chkwav(filein)
say "DYN:"
say ""
say "   filein       :" filein
say "   dinamica     :" dinamica
say ""

tr1 = WavAllocTrac(c)
tr2 = WavAllocTrac(c)
say time(E) ":" c*4 "bytes memoria allocata"
rcy = WavReadStereo(filein, tr1, tr2)
say time(E) ":" filein "caricato in memoria"

say time(E) ": traccia 1"
parse value WavAvg(tr1, c) with avg avg_abs
say time(E) ":" avg * 100 "% dallo 0"

rcy = WavDyn(tr1, c, dinamica)
say time(E) ": comp/exp eseguita"

max = WavPeak(tr1, c)
say time(E) ":" max * 100 "% di picco"

rcy = WavCopyTrac(tr1, tr1, c, (1/max), (1/max))
say time(E) ": normalizzato"


say time(E) ": traccia 2"
parse value WavAvg(tr2, c) with avg avg_abs
say time(E) ":" avg * 100 "% dallo 0"

rcy = WavDyn(tr2, c, dinamica)
say time(E) ": comp/exp eseguita"

max = WavPeak(tr2, c)
say time(E) ":" max * 100 "% di picco"

rcy = WavCopyTrac(tr2, tr2, c, (1/max), (1/max))
say time(E) ": normalizzato"


/* preview */
ctmp = fc * 10
if c<ctmp then ctmp = c
rcy = WavWriteStereo(filetmp, tr1, tr2, ctmp)
say time(E) ":" ctmp*4 "bytes scritti in" filetmp
call play "FILE="filetmp
say "OK? [s/N]"
pull resp

if ((resp=="s") | (resp=="S")) then do
   rcy = WavWriteStereo(filein, tr1, tr2, c)
   say time(E) ":" c*4 "bytes scritti in" filein
   end



fine:
rcy = WavDropTrac(tr1)
rcy = WavDropTrac(tr2)
say time(E) ": memoria rilasciata"
return 0



fineko:
say "fine ko !!!"
pull k
"exit"
/**********************************************************************/


