/* FADEIN */
signal on error name fineko
signal on failure name fineko
signal on halt name fineko

parse value init() with rcy
if rcy \= 0 then signal fineko

parse upper arg filein offset durata

if (filein == "") | (offset == "") then do
  say "FADEIN:"
  say "Taglia la parte iniziale di un file audio WAV fino ad un offset specificato"
  say "ed eventualmente sfuma l'inizio per la durata indicata"
  say ""
  say "Uso:"
  say "      fadein nome_file offset [durata]"
  say ""
  say "Parametri:"
  say "      nome_file    il nome di un file WAV (con estenzione)"
  say "      offset       il punto da cui comincia a copiare (secondi)"
  say "      durata       la durata della transizione dal silenzio (secondi)"
  return 1
  end

if durata == "" then durata=0

fc=44100

call SysCls
t=time(R)
c = chkwav(filein)
say "Fadein:"
say ""
say "   filein      :" filein
say "   offset (sec):" offset
say "   durata (sec):" durata
say ""

if ((offset * fc) + (durata * fc))> c then do
   say "Segmento oltre la fine del file"
   signal fineko
   end

tr1 = WavAllocTrac(c)
tr2 = WavAllocTrac(c)
say time(E) ":" c*4 "bytes memoria allocata"
rcy = WavReadStereo(filein, tr1, tr2)
say time(E) ":" filein "caricato in memoria"

rcy = WavCopyTrac(tr1 + (offset * fc), tr1, c - (offset*fc), 1, 1, 'LIN', 'NOMIX')
rcy = WavCopyTrac(tr2 + (offset * fc), tr2, c - (offset*fc), 1, 1, 'LIN', 'NOMIX')
if durata>0 then do
   rcy = WavCopyTrac(tr1, tr1, (durata*fc), 0, 1, 'LOG', 'NOMIX')
   rcy = WavCopyTrac(tr2, tr2, (durata*fc), 0, 1, 'LOG', 'NOMIX')
   say time(E) ": traccia copiata (fadein)"
   end

c = c - (offset * fc)
rcy = WavWriteStereo(filein, tr1, tr2, c)
say time(E) ":" c*4 "bytes scritti in" filein


fine:
rcy = WavDropTrac(tr1)
rcy = WavDropTrac(tr2)
say time(E) ": memoria rilasciata"
return 0



fineko:
say "fine ko !!!"
pull k
"exit"
/**********************************************************************/


