/* MERGE */
signal on error name fineko
signal on failure name fineko
signal on halt name fineko

parse value init() with rcy
if rcy \= 0 then signal fineko

parse upper arg file1 file2 offset

if (file1 == "") | (file2 == "") then do
  say "MERGE:"
  say "Somma due file a partire da una posizione (relativa mente al primo)"
  say ""
  say "Uso:"
  say "      MERGE primo_file secondo_file [offset]"
  say ""
  say "Parametri:"
  say "      primo_file   il nome di un file WAV stereo (con estenzione)"
  say "      secondo_file il nome di un file WAV stereo (con estenzione)"
  say "      offset       l'offset di inizio del segmento (secondi) rel. primo file"
  return 1
  end

if offset == "" then offset=0

fc=44100
filetmp="tmp.wav"

call SysCls
t=time(R)
c1 = chkwav(file1)
c2 = chkwav(file2)
say "MERGE:"
say ""
say "   file1       :" file1
say "   file2       :" file2
say "   offset (sec):" offset
say ""

o1=offset*fc

if (c2 + o1)>c1 then ctot = c2 + o1
                else ctot = c1

if c1<o1 then do
   say "Inizio segmento oltre la fine del primo file"
   signal fineko
   end



tr1 = WavAllocTrac(ctot)
tr2 = WavAllocTrac(ctot)
say time(E) ":" ctot*4 "bytes memoria allocata (primo file)"
rcy = WavReadStereo(file1, tr1, tr2)
say time(E) ":" file1 "caricato in memoria"

rcy = WavReadStereo(file2, (tr1 + o1), (tr2 + o1), 'MIX')
say time(E) ":" file2 "caricato in memoria"

/* preview */
o1 = o1 - (fc * 2)
if o1<0 then o1 = 0
ctmp = fc * 10
if ctot<ctmp then ctmp = ctot
rcy = WavWriteStereo(filetmp, (tr1 + o1), (tr2 + o1), ctmp)
say time(E) ":" ctmp*4 "bytes scritti in" filetmp
call play "FILE="filetmp
say "OK? [s/N]"
pull resp

if ((resp=="s") | (resp=="S")) then do
   rcy = WavWriteStereo(file1, tr1, tr2, ctot)
   say time(E) ":" ctot*4 "bytes scritti in" file1
   end


fine:
rcy = WavDropTrac(tr1)
rcy = WavDropTrac(tr2)
say time(E) ": memoria rilasciata"
return 0



fineko:
say "fine ko !!!"
pull k
"exit"
/**********************************************************************/


