/* MONO2ST */
signal on error name fineko
signal on failure name fineko
signal on halt name fineko

parse value init() with rcy
if rcy \= 0 then signal fineko

parse arg filein offset durata

if filein == "" then do
  say "MONO2ST:"
  say "Converte un file mono (1 canale) in uno stereo (2 canali)"
  say ""
  say "Uso:"
  say "      MONO2ST nome_file"
  say ""
  say "Parametri:"
  say "      nome_file    il nome di un file WAV monofonico (con estenzione)"
  return 1
  end

fc=44100

call SysCls
t=time(R)
c = chkwav(filein)
say "MONO2ST:"
say ""
say "   filein      :" filein
say ""

tr1 = WavAllocTrac(c)
say time(E) ":" c*2 "bytes memoria allocata"

rcy = WavReadMono(filein, tr1)
say time(E) ":" filein "caricato in memoria"

rcy = WavWriteStereo(filein, tr1, tr1, c)
say time(E) ":" c*4 "bytes scritti in" filein


fine:
rcy = WavDropTrac(tr1)
say time(E) ": memoria rilasciata"
return 0



fineko:
say "fine ko !!!"
pull k
"exit"
/**********************************************************************/



chkwav:
  arg NomeFile

parse value WavQueryFile(NomeFile) with canali freq bit camp
if canali == "NOWAV" then do
   say "Info:" NomeFile "non  un file wave"
   signal fineko
   end

if canali \= 1 then do
   say "Il file non  un file WAV mono!"
   signal fineko
   end

if freq \= fc then do
   say "La frequenza di campionamento" freq "non  gestita"
   signal fineko
   end

if bit \= 16 then do
   say "Il formato" bit "bit non  gestito"
   signal fineko
   end

return camp


